# Agents.jl: agent-based modeling framework in Julia

![Agents.jl](https://github.com/JuliaDynamics/JuliaDynamics/blob/master/videos/agents/agents3_logo.gif?raw=true)

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaDynamics.github.io/Agents.jl/stable)
[![](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaDynamics.github.io/Agents.jl/dev)
[![](https://img.shields.io/badge/arXiv-2101.10072-red)](https://arxiv.org/abs/2101.10072)
[![CI](https://github.com/JuliaDynamics/Agents.jl/workflows/CI/badge.svg)](https://github.com/JuliaDynamics/Agents.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaDynamics/Agents.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaDynamics/Agents.jl)

Agents.jl is a [Julia](https://julialang.org/) framework for agent-based modeling (ABM). All further information about Agents.jl are provided in the docs.

## Contributions

Any contribution to Agents.jl is welcome! For example you can:

  * Add new feature or improve an existing one (plenty to choose from the "Issues" page) 
  * Improve the existing documentation
  * Add new example ABMs into our existing pool of examples
  * Report bugs and suggestions in the Issues page

## Citation

If you use this package in a publication, please cite the paper below:
```
@misc{Agents.jl,
      title={Agents.jl: A performant and feature-full agent based modelling software of minimal code complexity}, 
      author={George Datseris and Ali R. Vahdati and Timothy C. DuBois},
      year={2021},
      eprint={2101.10072},
      archivePrefix={arXiv},
      primaryClass={cs.MA}
}
```
